package com.hzs.common.core.enums;

import com.hzs.common.core.constant.EnumsPrefixConstants;
import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * 奖项配置枚举
 */
@AllArgsConstructor
@Getter
public enum EBonusItems {

    /**
     * 直推收益
     */
    DIRECT_INCOME(3, "旧直推收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 3),
    /**
     * 拓展收益
     */
    EXPANSION_INCOME(4, "旧拓展收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 4),
    /**
     * 辅导收益
     */
    COACHING_INCOME(5, "旧辅导收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 5),
    /**
     * 分红收益
     */
    DIVIDEND_INCOME(6, "旧分红收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 6),
    /**
     * 服务补贴
     */
    SERVICE_SUBSIDIES(7, "旧服务补贴", 0, EnumsPrefixConstants.BONUS_ITEMS + 7),
    /**
     * 消费拓展收益
     */
    CONSUMPTION_EXPANSION_INCOME(9, "旧消费拓展收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 9),
    /**
     * 商城重销
     */
    RESALE_IN_THE_MALL(10, "商城重销", 0, EnumsPrefixConstants.BONUS_ITEMS + 10),
    /**
     * 平台服务费
     */
    PLATFORM_SERVICE_FEE(11, "旧平台服务费", 0, EnumsPrefixConstants.BONUS_ITEMS + 11),
    /**
     * 复购券
     */
    REPURCHASE_COUPONS(12, "旧复购券", 0, EnumsPrefixConstants.BONUS_ITEMS + 12),
    /**
     * 复购券均分收益
     */
    REPURCHASE_COUPONS_SHARE(13, "旧复购券均分", 0, EnumsPrefixConstants.BONUS_ITEMS + 13),
    /**
     * 店铺收益
     */
    STORE_INCOME(23, "旧店铺收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 23),

    ////////////////////////////////////////////////// 新奖项 //////////////////////////////////////////////////

    /**
     * 复购级差收益 -- 秒结，日奖
     */
    REPURCHASE_RANGE_INCOME(8, "复购级差收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 8),

    /**
     * 直推收益（新零售直推级差收益） -- 秒结，日奖
     */
    RETAIL_RANGE_INCOME(25, "直推收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 25),
    /**
     * 平级收益（新零售平级收益） -- 秒结，日奖
     */
    RETAIL_SAME_LEVEL_INCOME(26, "平级收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 26),
    /**
     * 区域分红（新零售区域收益） -- 秒结，日奖
     */
    RETAIL_AREA_INCOME(27, "区域分红", 0, EnumsPrefixConstants.BONUS_ITEMS + 27),

    /**
     * 福利极差收益 -- 月结，月奖
     */
    RETAIL_BENEFIT_RANGE_INCOME(30, "月度福利级差收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 30),
    /**
     * 复购级差收益（新） -- 月结，月奖
     */
    RETAIL_MONTH_REPURCHASE_INCOME(31, "月度复购级差收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 31),
    /**
     * 培育津贴（新） -- 月结，月奖
     */
    RETAIL_COACHING_INCOME(32, "培育津贴", 0, EnumsPrefixConstants.BONUS_ITEMS + 32),

    /**
     * 月度分红 - 平均收益（福利平均收益） -- 月结，月奖
     */
    RETAIL_BENEFIT_AVG_INCOME(28, "分红平均收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 28),
    /**
     * 月度分红 - 加权收益（福利加权收益） -- 月结，月奖
     */
    RETAIL_BENEFIT_INCOME(29, "分红加权收益", 0, EnumsPrefixConstants.BONUS_ITEMS + 29),

    ;

    public static EBonusItems getEnumByValue(int value) {
        for (EBonusItems eBonusItems : EBonusItems.values()) {
            if (eBonusItems.getValue() == value) {
                return eBonusItems;
            }
        }
        return null;
    }

    /**
     * 实际值
     */
    private final int value;
    /**
     * 显示标签
     */
    private final String label;
    /**
     * 是否启用（0=是,1=否） -- 来源EYesNo
     */
    private final int enable;
    /**
     * 国际化翻译key值
     */
    private final String key;
}
